#include <core/Solver.h>
#include <toSAT/LI/MDD.hh>

namespace Glucose {

NodeID MDD::findNode(int currentK, uint level) {
  Interval aux = Interval(currentK);
  std::set<Interval>::iterator it = lib[level].find(aux);
  if ( it != lib[level].end() ) {
    //assert(it->getA() <= currentK && it->getB() >= currentK);
    return it->getNodeID();
  }
  if ( currentK < 0) {
    NodeID nid = nodes.size();
    lib[level].insert(Interval(false,nid));
    nodes.push_back(Node(false,nid));
    //assert(lib[level].find(aux) != lib[level].end() && lib[level].find(aux)->getNodeID() == nid);
    return nid;
  }
  if (level == coeffs.size()) {
    NodeID nid = nodes.size();
    lib[level].insert(Interval(true,nid));
    nodes.push_back(Node(true,nid));
    //assert(lib[level].find(aux) != lib[level].end() && lib[level].find(aux)->getNodeID() == nid);
    return nid;
  }
  // General case:
  std::vector<NodeID> ch;
  std::vector<Interval> vi;
  int newK = currentK;
  for (int i = 0; i <= domains[level]; i++) {
    NodeID n = findNode(newK, level+1);
    ch.push_back(n);
    vi.push_back(nodes[n].getInterval());
    newK-=coeffs[level];
  }
  NodeID nid = nodes.size();
  lib[level].insert(Interval(vi,coeffs[level], nid));
  Interval interval(vi,coeffs[level], nid);
  nodes.push_back(Node(ch,interval,level));
  //assert(lib[level].find(aux) != lib[level].end() && lib[level].find(aux)->getNodeID() == nid);
  return nid;
}

};
