/* -*- mode: C++; c-basic-offset: 2; indent-tabs-mode: nil -*- */

/*
 *  Main authors:
 *     Ignasi Abio <iabio@nicta.com.au>
 */

/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */

#ifndef __MINIZINC_LI_COMMON_HH__
#define __MINIZINC_LI_COMMON_HH__

#include <vector>
#include <algorithm>
//#include <minizinc/ast.hh>

namespace Glucose {

namespace LI_Commons
{
  struct CmpInd {
    CmpInd(std::vector<int>& vec) : values(vec) {}
    bool operator() (const int& a, const int& b) const {
      return values[a] < values[b] || (values[a]==values[b] && &a < &b);
      //return a < b;
    }
    std::vector<int>& values;
  };

  inline void sort(std::vector<std::vector<Lit> >& l, std::vector<int>& c, bool inv) {
    std::vector<int> ind(c.size());
    for (uint i = 0; i < c.size(); i++) ind[i]=i;

    sort(ind.begin(), ind.end(), CmpInd(c));
    if (inv) {
      std::vector<int> newC(c);
      for (uint i = 0; i < ind.size(); i++)
	c[i]=newC[ind[i]];
      std::vector<std::vector<Lit> > newL(l);
      for (uint i = 0; i < ind.size(); i++)
	l[i]=newL[ind[i]];
    } else {
      std::vector<int> newC(c);
      for (uint i = 0; i < ind.size(); i++)
	c[ind.size()-i-1]=newC[ind[i]];
      std::vector<std::vector<Lit> > newL(l);
      for (uint i = 0; i < ind.size(); i++)
	l[ind.size()-i-1]=newL[ind[i]];
    }
  }
}

};

#endif
