#ifndef _Glucose_leq_h
#define _Glucose_leq_h

#include <toSAT/AMO/Heule.hh>
#include <toSAT/LI/MDD_LI.hh>

inline void/*Glucose::Var*/ clause(Glucose::Solver* s, const std::vector<std::vector<Glucose::Lit> >& x, Glucose::Lit halfreif) {
    Glucose::vec<Glucose::Lit> v(x.size()+1);
    for (uint i = 0; i < x.size(); i++)
        v[i]=x[i][0];
    v.last()=~halfreif; //Glucose::mkLit(s->newVar(), true);
    s->addClause(v);
    //return Glucose::var(v.last());
}

inline void /*Glucose::Var*/ amo(Glucose::Solver* s, const std::vector<std::vector<Glucose::Lit> >& x, Glucose::Lit halfreif) {
    std::vector<Glucose::Lit> x2(x.size());
    for (uint i=0; i<x.size(); i++)
        x2[i]=x[i][0];
    /*return*/ Glucose::Heule_AMO(s,x2,(intptr_t)4,halfreif);
}

inline void/*Glucose::Var*/ leq_LI(Glucose::Solver* s, const std::vector<int>& c, const std::vector<std::vector<Glucose::Lit> >& x, int b, Glucose::Lit halfreif) {
    /*return*/ Glucose::MDD_leqLI(s, c, x, b,(intptr_t)4., halfreif);
}

inline void/*Glucose::Var*/ leq_PB(Glucose::Solver* s, const std::vector<int>& c, const std::vector<std::vector<Glucose::Lit> >& x, int b, Glucose::Lit halfreif) {
    /*return*/ leq_LI(s, c, x, b, halfreif);
}

inline void/*Glucose::Var*/ leq_CC(Glucose::Solver* s, const std::vector<int>& c, const std::vector<std::vector<Glucose::Lit> >& x, int b, Glucose::Lit halfreif) {
    /*return*/ leq_LI(s, c, x, b, halfreif);
}

inline void/*Glucose::Var*/ leq(Glucose::Solver* s, const std::vector<int>& c, const std::vector<std::vector<Glucose::Lit> >& x, 
                                const std::vector<int>&lb, int b, Glucose::Lit halfreif) {
    std::vector<int> c2;
    std::vector<std::vector<Glucose::Lit> > x2;
    for (uint i = 0; i < c.size(); i++) {
        b-=c[i]*lb[i];
        if (c[i] > 0 && x[i].size() > 0) {
            c2.push_back(c[i]);
            x2.push_back(x[i]);
        } else if (c[i]<0 && x[i].size() > 0) {
            c2.push_back(-c[i]);
            x2.push_back(std::vector<Glucose::Lit>(x[i].size()));
            for (uint j=0; j<x[i].size(); j++)
                x2.back()[j]=~x[i][x[i].size()-j-1];
            b+=c2.back()*x[i].size();
        }
    }
    std::vector<Glucose::Lit> inc;
    //Glucose::Var ret = /*Glucose::*/var_Undef;
    if (b < 0) {
        s->addClause(~halfreif); //ret=s->var_false;
        return;
    }
    for (int i = 0; i < (int)c2.size(); i++)
        if (c2[i]*x2[i].size()>b) {
            s->addClause(x2[i][b/c2[i]], ~halfreif); //inc.push_back(x2[i][b/c2[i]]);
            x2[i].resize(b/c2[i]);
            if (x2[i].empty()) {
                x2[i].swap(x2.back());
                x2.pop_back();
                c2[i]=c2.back();
                c2.pop_back();
                i--;
            }
        }
    int t = 0;
    for (int i = 0; i < (int)c2.size(); i++)
        t+=c2[i]*x2[i].size();
    if (t <= b)
        return;
    for (uint i = 0; i < c2.size(); i++)
        if ( x2[i].size() > 1 ) {
            leq_LI(s,c2,x2,b,halfreif);
            return;
        }
    for (uint i = 0; i < c2.size(); i++)
        if ( c2[i]>1 ) {
            leq_PB(s,c2,x2,b,halfreif);
            return;
        }
    if(b == c2.size()-1)
        clause(s,x2,halfreif);
    else if (b == 1)
        amo(s,x2,halfreif);
    else
        leq_CC(s,c2,x2,b,halfreif);
}

#endif
